//////////////////////////////////////////////////////////////////////
// (C)2006 by Brian Postma
//////////////////////////////////////////////////////////////////////


#include <math.h>
#include "BouncingLogo.h"
#include "SDLBitmap16.h"

extern unsigned char logo[];

const int BouncingLogo::picw=272;
const int BouncingLogo::pich=56;


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BouncingLogo::BouncingLogo()
{
  bitmap=new SDLBitmap16(logo,picw,pich);
  bitmap->SetTransparentColor(0);
  srcsurface=bitmap->GetSurface();
  sinp1=0;
  sinp2=SINSIZE/5;
  for (int i=0; i<SINSIZE; i++)
  {
    sine[i]=(320-picw)/2+int((double)(320-picw)*(sin(2*3.141592*i/SINSIZE)/2.0));
  }
}

BouncingLogo::~BouncingLogo()
{
  delete bitmap;
}

//////////////////////////////////////////////////////////////////////

void BouncingLogo::Draw(SDL_Surface *dstsurface)
{
  SDL_Rect dst= { sine[sinp1],sine[sinp2]>>1,picw,pich };
  SDL_BlitSurface(srcsurface,NULL,dstsurface,&dst);

  sinp1+=2;
  if (sinp1>=SINSIZE)
    sinp1-=SINSIZE;
  sinp2+=3;
  if (sinp2>=SINSIZE)
    sinp2-=SINSIZE;
}

//////////////////////////////////////////////////////////////////////
