//////////////////////////////////////////////////////////////////////
// (C)2006 by Brian Postma
//////////////////////////////////////////////////////////////////////

#include "CopperBars.h"
#include <math.h>

#define NUMBARS 7

unsigned short cols[] = { 
        0x0008,0x0010,0x0018,0x001f,0x001f,0x0018,0x0010,0x0008,
        0x4008,0x8010,0xc018,0xf81f,0xf81f,0xc018,0x8010,0x4008,
        0x4000,0x8000,0xc000,0xf800,0xf800,0xc000,0x8000,0x4000,
        0x4200,0x8400,0xc600,0xffe0,0xffe0,0xc600,0x8400,0x4200,
        0x0200,0x0400,0x0600,0x07e0,0x07e0,0x0600,0x0400,0x0200,
        0x0208,0x0410,0x0618,0x07ff,0x07ff,0x0618,0x0410,0x0208,
        0x0008,0x0010,0x0018,0x001f,0x001f,0x0018,0x0010,0x0008,
};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CopperBars::CopperBars(int min, int max)
{
  int ampl=(max-min-8)/2;
  for (int i=0; i<SINESIZE; i++)
    sine[i]=min+ampl+int((double)ampl*sin(2*3.141592*i/SINESIZE));
  sinp=0;
}

CopperBars::~CopperBars()
{

}


void CopperBars::Draw(SDL_Surface *dstsurface)
{
  SDL_LockSurface(dstsurface);
  sinp++;
  if (sinp>=SINESIZE) sinp-=SINESIZE;
  int p=sinp;
  unsigned short *ptr;
  int col=0;
  for (int i=0; i<NUMBARS; i++)
  {
    p+=5;
    if (p>=SINESIZE) p-=SINESIZE;
    ptr=(unsigned short *)dstsurface->pixels+sine[p]*dstsurface->w;
    for (int y=0; y<8; y++)
    {
      for (int x=0; x<dstsurface->w; x++)
        *ptr++=cols[col];
      col++;
    }
  }
  SDL_UnlockSurface(dstsurface);
}
