//////////////////////////////////////////////////////////////////////
// (C)2006 by Brian Postma
//////////////////////////////////////////////////////////////////////

#include "Menu8x8.h"
#include "Text8x8.h"

const int Menu8x8::fonth=8;
const int Menu8x8::fontw=8;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Menu8x8::Menu8x8(int y, int h, Text8x8 *txt)
{
  cursor=0;
  y1pos=y+1;
  y2pos=y+h;
  count=(h-1)/fonth;
  cursorpos=count/2;
  textobj=txt;
}

Menu8x8::~Menu8x8()
{

}

//////////////////////////////////////////////////////////////////////

void Menu8x8::AddItem(string &itm, string &userdata)
{
  menulist.push_back(itm);
  userlist.push_back(userdata);
}

//////////////////////////////////////////////////////////////////////

void Menu8x8::Draw(SDL_Surface *surface)
{
  int i,j;
  const unsigned short colors[] = { 0x4000, 0x8000, 0xc000, 0xF800, 0xc000,0x8000, 0x4000 };
  unsigned short *ptr=((unsigned short *)surface->pixels)+surface->w*(y1pos+cursorpos*fonth);
  SDL_LockSurface(surface);

  for (i=0; i<7; i++)
    for (j=0; j<surface->w; j++)
      *ptr++=colors[i];
  unsigned short *ptr1=(((unsigned short *)surface->pixels)+surface->w*(y1pos-1));
  unsigned short *ptr2=(((unsigned short *)surface->pixels)+surface->w*y2pos);

  for (i=0; i<surface->w; i++)
  { *ptr1++=0xF800; *ptr2++=0xF800; }

  SDL_UnlockSurface(surface);
  int s=cursor-cursorpos;
  int y=y1pos;
  while (y<(y2pos-fonth))
  {
    if (s>=0 && s<menulist.size())
    {
      textobj->DrawString(surface,menulist[s].c_str(),-1,y); 
    }
    s++;
    y+=fonth;
  }
}

//////////////////////////////////////////////////////////////////////

void Menu8x8::NextSelection()
{
  cursor++;
  if (cursor>=menulist.size())
    cursor=0;
}

void Menu8x8::PreviousSelection()
{
  cursor--;
  if (cursor<0)
    cursor=menulist.size()-1;
}


void Menu8x8::NextSelection8()
{
  cursor+=8;
  if (cursor>=menulist.size())
    cursor=menulist.size()-1;
}

void Menu8x8::PreviousSelection8()
{
  cursor-=8;
  if (cursor<0)
    cursor=0;
}

//////////////////////////////////////////////////////////////////////

const char *Menu8x8::GetSelection()
{
  if (userlist.size()<=0)
    return NULL;
  return userlist[cursor].c_str();
}

//////////////////////////////////////////////////////////////////////
