//////////////////////////////////////////////////////////////////////
// (C)2006 by Brian Postma
//////////////////////////////////////////////////////////////////////

#ifndef _SDLFRAMEWORK_H
#define _SDLFRAMEWORK_H

//////////////////////////////////////////////////////////////////////

#include <SDL.h>

//////////////////////////////////////////////////////////////////////

class SDLFramework  
{
public:
	SDLFramework();
	virtual ~SDLFramework();
  void run();
  static float Random(float min, float max);
  static const double pi;

protected:
  static const unsigned int framedelay;
  static const int scrwidth;
  static const int scrheight;

  virtual void DoIt(SDL_Surface *surface);
  virtual bool Init();
#ifdef TARGET_GP2X
  void KeyUp(const Uint8& key);
  void KeyDown(const Uint8& key);
#else
  void KeyUp(const SDLKey& key);
  void KeyDown(const SDLKey& key);
#endif
  void KeyHandler();
  inline static void SwapInts(int &i1, int &i2)
  {
    int i=i1; i1=i2; i2=i;
  }
 
  void ClrScreen(short color);
  static void PutPixel(SDL_Surface *surface, int x, int y,unsigned short color);
  static unsigned short GetPixel(SDL_Surface *surface, int x, int y);
  static void HLine(SDL_Surface *surface, int y, int x1, int x2, unsigned short color);
  static void VLine(SDL_Surface *surface, int x, int y1, int y2, unsigned short color);
  static void Line(SDL_Surface *surface, int x1, int y1, int x2, int y2, unsigned short color);
  static void ClippedLine(SDL_Surface *surface, int x1, int y1, int x2, int y2, unsigned short color);
  static void FillTriangle(SDL_Surface *surface, int x1, int y1, int x2, int y2, int x3, int y3, 
                           unsigned short color,unsigned short outlinecolor);
  inline static void FillTriangle(SDL_Surface *surface, int *x, int *y, unsigned short color,unsigned short outlinecolor)
  {
    FillTriangle(surface,x[0],y[0],x[1],y[1],x[2],y[2],color,outlinecolor);
  }
  static unsigned short GetRGBColor(int r, int g, int b)
  {
    return ((r&0xf8)<<8)|((g&0xfc)<<3)|((b&0xf8)>>3);
  }

  SDL_Surface *surface;
  bool quit,up,down,left,right,buttona,buttonb,buttonl,buttonr;
  bool buttonx,buttony,buttonvolplus,buttonvolmin,buttonselect;

private:
  SDL_Surface *mainsurface;
  short *screen;
  SDL_Joystick *joystick;
};

#endif
