//////////////////////////////////////////////////////////////////////
// (C)2006 by Brian Postma
//////////////////////////////////////////////////////////////////////

#ifndef _SDLFRAMEWORK3D_H
#define _SDLFRAMEWORK3D_H

#define SINECLICKS 10
#define SINETABLESIZE 360*SINECLICKS

#include "SDLFramework.h"

class SDLFramework3D : public SDLFramework  
{
public:
	SDLFramework3D();
	virtual ~SDLFramework3D();
  static void Fill3DTriangle(SDL_Surface *surface, int *x, int *y, int *z,
                             unsigned short color);
  static void Coord2D(SDL_Surface *surface, int x, int y, int z, int &x2d, int &y2d);
  void ClrScreen(short color);
  static void RotX(double angle, int *x, int *y, int *z, int count);
  static void RotY(double angle, int *x, int *y, int *z, int count);
  static void RotZ(double angle, int *x, int *y, int *z, int count);
  static void Translate(int t_x, int t_y, int t_z, int *x, int *y, int *z, int count);
  static void RotXclicks(int clicks, int *x, int *y, int *z, int count);
  static void RotYclicks(int clicks, int *x, int *y, int *z, int count);
  static void RotZclicks(int clicks, int *x, int *y, int *z, int count);
  static void RotXclicks(int clicks, int *x, int *y, int *z, int *xdst, int *ydst, int *zdst, int count);
  static void RotYclicks(int clicks, int *x, int *y, int *z, int *xdst, int *ydst, int *zdst, int count);
  static void RotZclicks(int clicks, int *x, int *y, int *z, int *xdst, int *ydst, int *zdst, int count);
  inline int Degrees2Clicks(float degrees)
  {
    return (int)(degrees*float(SINECLICKS));
  }

protected:
  static int Sin(int angle);
  static int Cos(int angle);

private:
  static void HLine3D(SDL_Surface *surface, int y, int x1, int x2, 
                    int z1, int z2, unsigned short color);
  static void FillTriangle3D(SDL_Surface *surface,   int x1, int y1, int z1,
                           int x2, int y2, int z2, int x3, int y3, int z3,
                           unsigned short color);
  static int zoomfactor;
  static short zbuffer[320*240];
  static int sinetable[SINETABLESIZE];
};

#endif 
