//////////////////////////////////////////////////////////////////////
// (C)2006 by Brian Postma
//////////////////////////////////////////////////////////////////////

#include "Scroller.h"
#include "SDLBitmap16.h"

extern unsigned char font[];

const int Scroller::fontw=32;
const int Scroller::fonth=32;
const int Scroller::picw=320;
const int Scroller::pich=200;
const int Scroller::depth=16;
const int Scroller::bytes=depth/8;

char *Scroller::order=
" !\"#*  '()  ,-. 0123456789:;   ? ABCDEFGHIJKLMNOPQRSTUVWXYZ ";

char *Scroller::scrolltext=" ... IN MY NEVER ENDING QUEST TO PORT MY SOUNDMON PLAYER "
"TO EVERY DEVICE THAT IS CAPABLE OF PRODUCING SOUND, THIS IS BRIAN'S SOUNDMON PLAYER "
"FOR THE GP2X ... SINCE SOUNDMON ORIGINATED ON THE COMMODORE AMIGA BACK IN 1987 (1989 "
"FOR THE VERSION USING SYNTHESIZED SOUNDS) I TRIED TO MAKE THIS PLAYER LOOK "
"LIKE AN AMIGA DEMO FROM THE 1980'S ... USE JOYSTICK UP-DOWN TO SELECT AN ENTRY "
"FROM THE MENU, USE LEFT-RIGHT SHOULDER BUTTONS TO MOVE THROUGH THE MENU QUICKER, "
"USE 'B' BUTTON TO SELECT AND PLAY A TUNE, USE 'X' AND 'Y' "
"BUTTONS, OR VOLUME UP-DOWN, TO CHANGE THE VOLUME. PRESS 'START' TO QUIT (JUST LIKE "
"WINDOS ;-) ... SOME CREDITS: INCLUDED MUSICS DONE BY SEBASTIAAN 'ZZZAX' LENTFERT "
"AND ALLISTER BRIMBLE, CODE DONE BY BRIAN POSTMA, GRAPHICS (FONTS) RIPPED FROM AN "
"OLD AMIGA DEMO: CREATOR IS UNKNOWN ... YOU CAN E-MAIL ME AT BRIAN#BRIANPOSTMA.COM "
"- DOWNLOAD THE SOURCE CODE OF THIS THING AT \"WWW.BRIANPOSTMA.COM\" - "
"    THIS IS A TIMECIRCLE PRODUCTION (C)2006 .....          "; 

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Scroller::Scroller(int scrwidth, int pos)
{
  vpos=pos;
  scrw=scrwidth;
  bufw=(scrw+fontw);
  charsperline=picw/fontw;

  bitmap=new SDLBitmap16(font,picw,pich);
  fontsurface=bitmap->GetSurface();
  srcsurface=SDL_CreateRGBSurface(SDL_HWSURFACE,2*bufw,fonth,depth,0xF800,0x07E0,0x001F,0);
  SDL_SetColorKey(srcsurface,SDL_SRCCOLORKEY,0);
  scrollptr=scrolltext;
  count=1;
  scrpos=-1;
}

Scroller::~Scroller()
{
  delete bitmap;
  SDL_FreeSurface(srcsurface);
}

//////////////////////////////////////////////////////////////////////

void Scroller::scroll(SDL_Surface *dstsurface)
{
  scrpos++;
  if (scrpos>=bufw)
    scrpos=0;
  count--;
  if (count<=0)
  {
    count=fontw;
    scrollptr++;
    if (*scrollptr==0)
      scrollptr=scrolltext;
    char ch=*scrollptr;
    char *tmp=order;
    int k=0;
    while (tmp[k]!=ch && tmp[k]!=0) k++;
    if (tmp[k]==0)
      return;
    int y=fonth*(int)(k/charsperline);
    int x=fontw*(k%charsperline);
    SDL_Rect src= { x,y,fontw,fonth };
    SDL_Rect dst= {scrpos+scrw,0,fontw,fonth};
    SDL_BlitSurface(fontsurface,&src,srcsurface,&dst);
    dst.x+=bufw;
    if (dst.x>=2*bufw)
      dst.x-=2*bufw;
    SDL_BlitSurface(fontsurface,&src,srcsurface,&dst);
  }
  SDL_Rect src={ scrpos,0,scrw,fonth};
  SDL_Rect dst={ 0,vpos,scrw,fonth};
  SDL_BlitSurface(srcsurface,&src,dstsurface,&dst);
}
