//////////////////////////////////////////////////////////////////////
// (C)2006 by Brian Postma
//////////////////////////////////////////////////////////////////////

#include "ShowWaves.h"
#include "Soundmon.h"
#include "LSoundPlayer.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ShowWaves::ShowWaves(int vpos)
{
  ypos=vpos;
}

ShowWaves::~ShowWaves()
{

}

//////////////////////////////////////////////////////////////////////

void ShowWaves::Draw(SDL_Surface *dstsurface)
{
  LSoundPlayer *soundplayer=GetSoundPlayer();
  if (soundplayer==NULL)
    return;
  unsigned char *memptr=soundplayer->showbuf;
  SDL_LockSurface(dstsurface);
  DrawWave(dstsurface,0,memptr);
  DrawWave(dstsurface,85,memptr+32);
  DrawWave(dstsurface,170,memptr+64);
  DrawWave(dstsurface,255,memptr+96);

  int w=dstsurface->w;
  unsigned short *disp=(unsigned short *)dstsurface->pixels+(ypos+16)*w;

  for (int i=0; i<20; i++)
  {
    disp[w+65+i]=0xFFFF;
    disp[65+i]=0x8410;
    disp[w*2+65+i]=0x8410;

    disp[w+150+i]=0xFFFF;
    disp[150+i]=0x8410;
    disp[w*2+150+i]=0x8410;

    disp[w+235+i]=0xFFFF;
    disp[235+i]=0x8410;
    disp[w*2+235+i]=0x8410;
  }
  SDL_UnlockSurface(dstsurface);
}


/*
void ShowWaves::DrawWave(SDL_Surface *dstsurface, int x, unsigned char *ptr)
{
  unsigned short *disp=(unsigned short *)dstsurface->pixels, *dispptr;
  int w=dstsurface->w;
  int b;

  for (int i=0; i<32; i++)
  {
    b=ypos+(ptr[i]>>3);
    dispptr=disp+w*b+x+(i<<1);
    dispptr[w]=0xFFFF;
    dispptr[w+1]=0xFFFF;
    dispptr[0]=0x8410;
    dispptr[1]=0x8410;
    dispptr[w*2]=0x8410;
    dispptr[w*2+1]=0x8410;
  }
}
*/


void ShowWaves::DrawWave(SDL_Surface *dstsurface, int x, unsigned char *ptr)
{
  int w=dstsurface->w;
  unsigned short *disp=(unsigned short *)dstsurface->pixels+ypos*w, *dispptr;
  int y,yold,i;
  yold=(128>>3);
  for (i=0; i<32; i++)
  {
    y=(ptr[i]>>3);
    dispptr=disp+w*y+x+(i<<1);
    if (yold<y)
      Plot(dispptr,y-yold,-w);
    else
      Plot(dispptr,yold-y,w);
    yold=y;
  }
  y=(128>>3);
  dispptr=disp+w*y+x+(i<<1);
  if (yold<y)
    Plot(dispptr,y-yold,-w);
  else
    Plot(dispptr,yold-y,w);
}


void ShowWaves::Plot(unsigned short *ptr, int count, int w)
{
  ptr+=w;
  while (count>=0)
  {
    ptr[0]=0xFFFF;
    ptr[1]=0xFFFF;
    ptr+=w;
    count--;
  }
  ptr[0]=0x8410;
  ptr[1]=0x8410;
}