//////////////////////////////////////////////////////////////////////
// (C)2006 by Brian Postma
//////////////////////////////////////////////////////////////////////

#include "Stars.h"
#include "SDLFramework.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Stars::Stars(int min, int max)
{
  count=(max-min-2)/2;
  xpos=new int[count];
  xv=new int[count];
  y1pos=min;
  for (int i=0; i<count; i++)
  {
    xpos[i]=(int)SDLFramework::Random(0,319);
    xv[i]=(int)SDLFramework::Random(1,4);
  }
}

Stars::~Stars()
{
  delete[] xpos;
  delete[] xv;
}

void Stars::Draw(SDL_Surface *dstsurface)
{
  SDL_LockSurface(dstsurface);
  int w=dstsurface->w;
  unsigned short *ptr=(unsigned short *)dstsurface->pixels+y1pos*w;

  for (int i=0; i<count; i++)
  {
    ptr[xpos[i]+w]=0xFFC0;
    ptr[xpos[i]+w+1]=0xC000;
    ptr[xpos[i]]=0xC000;
    ptr[xpos[i]+w+w]=0xC000;
    ptr[xpos[i]+w+2]=0x6000;
    xpos[i]-=xv[i];
    if (xpos[i]<0)
      xpos[i]+=dstsurface->w-1;
    ptr+=w*2;
  }
  SDL_UnlockSurface(dstsurface);
}
