//////////////////////////////////////////////////////////////////////
// (C)2006 by Brian Postma
//////////////////////////////////////////////////////////////////////

#include <string.h>
#include "Text8x8.h"
#include "SDLBitmap16.h"

extern unsigned char font8x8[];

const int Text8x8::fontw=8;
const int Text8x8::fonth=8;
const int Text8x8::depth=16;
const int Text8x8::picw=568;


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Text8x8::Text8x8()
{
  bitmap=new SDLBitmap16(font8x8,picw,fonth);
  bitmap->SetTransparentColor(0);
  fontsurface=bitmap->GetSurface();
}

Text8x8::~Text8x8()
{
  delete bitmap;
}

//////////////////////////////////////////////////////////////////////

void Text8x8::DrawChar(SDL_Surface *dstsurface, char ch, int x, int y)
{
  if (ch>='a' && ch<='z')
    ch=ch-'a'+'A';
  if (ch<32 || ch>102)
    ch=32;
  SDL_Rect src={(ch-32)*fontw,0,fontw,fonth};
  SDL_Rect dst={x,y,fontw,fonth};
  SDL_BlitSurface(fontsurface,&src,dstsurface,&dst);
}

//////////////////////////////////////////////////////////////////////

void Text8x8::DrawString(SDL_Surface *dstsurface, const char *str, int x, int y)
{
  if (x<0)
  {
    x=(dstsurface->w-fontw*strlen(str))/2;
  }
  char ch=*str++;
  while (ch!=0)
  {
    DrawChar(dstsurface,ch,x,y);
    ch=*str++;
    x+=fontw;
  }
}

//////////////////////////////////////////////////////////////////////

void Text8x8::DrawNumber(SDL_Surface *dstsurface, unsigned short num, int x, int y)
{
  char buf[6];
  unsigned short div=10000;
  for (int i=0; i<5; i++)
  {
    buf[i]=(char)(num/div+'0');
    num=num%div;
    div=div/10;
  }
  buf[5]=0;
  DrawString(dstsurface,buf,x,y);
}

//////////////////////////////////////////////////////////////////////
